#define maxN 1000
#define m 1000003

#include <stdio.h>

char letters[maxN][maxN]; //   (   ,  )
char word[2 * maxN - 1];  //  
int N, cnt[maxN][maxN];   //  cnt[line][row]           

//        ,   ,
//       cnt[line][row],    line
//    row     ,  0,  .  
//   ,      . ³ , 
//       .
inline int getCount(int line, int row)
{
    if (line == 0 && row < 0)
        return 1;
    else if (line < 0 || row < 0)
        return 0;
    else
        return cnt[line][row];
}

int main()
{
    freopen("line.dat", "r", stdin);
    freopen("line.sol", "w", stdout);

    //  :
    scanf("%d\n", &N);
    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j < N; j++)
            scanf("%c", &letters[i][j]);
        scanf("\n");
    }
    for (int i = 0; i < 2 * N - 1; i++)
        scanf("%c", &word[i]);

    for (int i = 0; i < N; i++) //     
        for (int j = 0; j < N; j++)
            cnt[i][j] = letters[i][j] == word[i + j]
                        ? (getCount(i - 1, j) + getCount(i, j - 1)) % m
                        : 0; //         ,    , , 

    //    ,     :
    printf("%d\n", cnt[N - 1][N - 1]);
    return 0;
}
