#include <iostream>
#include <string>
#include <memory.h>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <fstream>
#include <queue>
#include <list>

using namespace std;
#define pb push_back
#define mp make_pair
#define FOR(i,a,b) for(int i=a;i<b;++i)
const int inf = 1000000001;
int all, st, fn;
int pr[2005];
int f[505][505], q[505][505];
int n, m;
bool used[505];
bool bfs() {
    for(int i=0;i<all;++i){
        pr[i]=-1; used[i]=false;
    }
    vector<int> o;
    o.push_back(0);
    int cur = 0;
    while (cur < o.size() && !used[fn]) {
        int x = o[cur++];
        used[x] = true;
        for (int i = 0; i < all; ++i) {
            if (f[x][i] - q[x][i]>0 && !used[i]) {
                used[i]=true;
                pr[i]=x;
                o.push_back(i);
            }
        }
    }
    return used[fn];
}
int maxFlow() {
    int ret = 0;
    for (;;) {
        if (!bfs()) return ret;
        ret++;
        int n=all-1;
        while (n > 0) {
            q[pr[n]][n]++;
            q[n][pr[n]]--;
            n=pr[n];
        }
    }
    return ret;
}
int r[505], c[505];
void solve() {
    int n, m;
    int sr = 0, sc = 0;
    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &r[i]);
        sr += r[i];
    }
    for (int i = 0; i < m; ++i) {
        scanf("%d", &c[i]);
        sc += c[i];
    }
    if (sr != sc) {
        puts("0");
        return;
    }

    all = n + m + 2;
    st = 0, fn = n + m + 1;
    for (int i = 0; i < all; ++i) {
        for (int j = 0; j < all; ++j) {
            f[i][j] = 0;
            q[i][j] = 0;
        }
    }

    for (int i = 0; i < n; ++i) {
        f[0][i + 1] = r[i];
    }
    for (int i = 0; i < m; ++i) {
        f[i + n + 1][all - 1] = c[i];
    }

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) {
            f[i + 1][j + n + 1] = 1;
        }

    int flow = maxFlow();
    if (flow != sr) {
        puts("0");
        return;
    }
    puts("1");
}
int main() {
    freopen("puzzle.dat","r",stdin);
    freopen("puzzle.sol","w",stdout);
    //freopen("input.txt","r",stdin);
    int T;
    scanf("%d", &T);
    while (T--) {
        solve();
    }
    return 0;
}
