const maxSize = 1000000;

var T, N, M, test, i: longint;
var cols, rows: array[0 .. maxSize - 1] of longint;
var colsIndex, rowsIndex: array[0..maxSize] of longint;

function check: boolean;
var i, colPointer, rowPointer, currentRowCount: longint;
colSum, rowSum, currentColSum, currentRowSum: int64;
begin
    for i := 0 to M do
        colsIndex[i] := 0;
    colSum := 0;
    for i := 0 to N - 1 do begin
        inc(colSum, cols[i]);
        inc(colsIndex[cols[i]]);
    end;

    for i := 0 to N do
        rowsIndex[i] := 0;
    rowSum := 0;
    for i := 0 to M - 1 do begin
        inc(rowSum, rows[i]);
        inc(rowsIndex[rows[i]]);
    end;

    if colSum <> rowSum then begin
        check := false;
        exit;
    end;

    colPointer := M;
    currentColSum := 0;
    rowPointer := 0;
    currentRowCount := M;
    currentRowSum := 0;
    while colPointer >= 0 do
        if colsIndex[colPointer] > 0 then begin
            dec(colsIndex[colPointer]);
            inc(currentColSum, colPointer);

            dec(currentRowCount, rowsIndex[rowPointer]);
            inc(rowPointer);
            inc(currentRowSum, currentRowCount);

            if currentColSum > currentRowSum then begin
                check := false;
                exit;
            end;
        end else
            dec(colPointer);

    check := true;
end;

begin
    assign(input, 'puzzle.dat');
    reset(input);
    assign(output, 'puzzle.sol');
    rewrite(output);

    read(T);
    for test := 0 to T - 1 do begin
        read(N, M);
        for i := 0 to N - 1 do
            read(cols[i]);
        for i := 0 to M - 1 do
            read(rows[i]);
        if check() then
            writeln(1)
        else
            writeln(0);
    end;
end.
