#include <iostream>
#include <string>
#include <memory.h>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <fstream>
#include <queue>
#include <list>

using namespace std;
#define pb push_back
#define mp make_pair
#define FOR(i,a,b) for(int i=a;i<b;++i)
vector < pair < int, int > > pts;
int x[100005], y[100005], r[100005];
int n, m;
int get(pair < int, int > a, pair < int, int > b, pair < int, int > c) {
    long long A, B, C;
    A = b.second - a.second;
    B = a.first - b.first;
    C = -A * a.first - B*a.second;
    long long val = A * c.first + B * c.second + C;
    int is = 0;
    if (val > 0) is = 1; else if (val < 0) is = -1;
    return is;
}
bool check(int xx, int yy) {
    bool sit = false;
    for (int i = 0; i < m; ++i) {
        long long xs = x[i] - xx, ys = y[i] - yy;
        if (xs * xs + ys * ys <= 1LL * r[i] * r[i]) sit = true;
    }
    if (!sit) return false;
    int is = 0;
    for (int i = 0; i < n; ++i) {
        int zn = get(pts[i], pts[i + 1], make_pair(xx, yy));
        if (zn != 0) {
            if (is == 0) is = zn;
            if (is != zn) return false;
        }
    }
    return true;
}
int main() {
    freopen("trees.dat", "r", stdin);
    freopen("trees.sol", "w", stdout);
     
//  freopen("/media/furko/621204A7120481F1/furko/UOI2015/Air/tests/input0.tst","r",stdin);
//    freopen("/media/furko/621204A7120481F1/furko/UOI2015/Air/tests/output0.ans", "w",stdout);
    scanf("%d", &n);
    int minx = 0, miny, maxx, maxy;
    for (int i = 0; i < n; ++i) {
        int x, y;
        scanf("%d%d", &x, &y);
        pts.push_back(make_pair(x, y));
        if (i == 0) {
            minx = x; maxx = x; miny = y; maxy = y;
        }
        minx = min(minx, x); maxx = max(maxx, x);
        miny = min(miny, y); maxy = max(maxy, y);
    }
    pts.push_back(pts[0]);
    scanf("%d", &m);
    for (int i = 0; i < m; ++i) {
        scanf("%d%d%d", &x[i], &y[i], &r[i]);
    }
    int ans = 0;
    for (int i = minx; i <= maxx; ++i) {
        for (int j = miny; j <= maxy; ++j) {
            if (check(i, j)) ans++;
        }
    }

    cout << ans << endl;
    return 0;
}

